=== debian/changelog ===
ros-melodic-tuw-geometry (0.0.3-0bionic) bionic; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Markus Bader <markus.bader@tuwien.ac.at>  Mon, 24 Sep 2018 13:50:29 -0000
