=== debian/control ===
Source: ros-melodic-tuw-geometry
Section: misc
Priority: extra
Maintainer: Markus Bader <markus.bader@tuwien.ac.at>
Build-Depends: debhelper (>= 9.0.0), libboost-all-dev, libeigen3-dev, ros-melodic-catkin, ros-melodic-cv-bridge, ros-melodic-roscpp, ros-melodic-rospy, ros-melodic-rosunit, ros-melodic-std-msgs
Homepage: 
Standards-Version: 3.9.2

Package: ros-melodic-tuw-geometry
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-melodic-cv-bridge, ros-melodic-roscpp, ros-melodic-rospy, ros-melodic-std-msgs
Description: The tuw_geometry package
